--
-- H O R I Z O N T A L    S U N D I A L    ADA LANGUAGE
--
-- Simon Wheaton-Smith July 2009
-- www.illustratingshadows.com
-- open source
-- GPS-GNAT, BUILD, PROJECT, BUILD <CURRENT FILE>
--           NOTE: BUILD ALL does not create EXE file
-- then      RUN, CUSTOM, enter the exe file name
-- GPS-GNAT  available from www.adacore.com (professional)
--           http://libre.adacore.com/libre (free version)
--

-- with     these libraries are needed
with Ada.Text_IO;                        -- put etc
with Ada.Float_Text_IO;                  -- float
with Ada.Integer_Text_IO;
with Ada.Numerics.Elementary_Functions;  -- sin cos tan



-- use      abbreviate ADA functions and look in here
use  Ada.text_io ;
use  Ada.Float_Text_IO;
use  Ada.Integer_Text_IO;
use  Ada.Numerics.Elementary_Functions;

--
-- M A I N    P R O G R A M
--
procedure programhdial is

   --
   -- a function to add one to a number
   --
   function addOne (k: in Integer) return Integer is
   begin
      return k + 1;
   end addOne;

   -- location for print out and it is string
   -- loc      : String (1..80);
   -- N        : Natural;

   -- dial latitude and longitude as float
   lat      : float ;
   lng      : float ;
   slat     : float ;

   -- legal meridian as integer which we convert to float
   refInt   : integer;
   ref      : float  ;
   dlng     : float  ;
   thra     : float  ;                 -- tan of hour angle
   hla      : float  ;                 -- hour line angle

   -- this is how we get clean formattted fixed point
   -- see: http://pleac.sourceforge.net/pleac_ada/numbers.html
   type Real is delta 0.1 digits 12;
   hlaF     : real   ;
   dlngF    : real   ;

   hr       : Natural;

   -- a header which could have been a literal
   msg1     : string (1..22) := "Lng diff:             " ;
   f1       : float;

   --
   -- the main program guts
   --
   begin

   put     ("www.illustingshadows.com     ");
   put     ("programhdial   July 2009");
   put_line(" ");

   -- put_line("Enter dial location as text ");
   -- Get_Line (loc, N);

   put_line("Enter latitude  as  nn.n ");
   Get     (lat);

   put_line("Enter longitude as nnn.n");
   Get     (lng);

   put_line("Enter meridian  as nnn ");
   Get     (refInt);     -- see: use  Ada.Integer_Text_IO;
   ref     := float (refInt) ;

   -- say dial details
   slat    := sin(lat*2.0*3.1416/360.0);
   put     ("sin of lat:           ");
   put     (slat);
   put_line (" ");

   dlng    := lng - ref ;
   put     (msg1);
   -- see: http://pleac.sourceforge.net/pleac_ada/numbers.html
   dlngF := Real (dlng) ;
   put ( Real'Image(dlngF) );
   put_line (" ");

   put     ( "Minutes correction:   ");
   dlngF := Real (dlng*4.0) ;
   put ( Real'Image(dlngF) );
   put_line (" ");

   -- start the hour line loop
   hr := 6 ;
   loop
      put ("Hour: ");
      put ( hr);

      thra := tan( (float(hr) - (dlng/15.0) ) * 15.0 * 2.0 * 3.1416 / 360.0 ) ;
      f1   := thra * slat ;

      -- hla := arctan ( slat * thra ) ;
      hla := arctan(f1) * 360.0 / ( 2.0 * 3.1416 ) ;

      put ("   hour line angle: ");

      hlaF := Real (hla) ;
      put ( Real'Image(hlaF) );

      put_line (" ");
      exit when hr = 18;
      hr := addOne (hr) ;               -- hr := hr + 1;
   end loop;

 end programhdial;
